/*\
|*| --------------------------------------------------------------------------
|*|	generic CLUT manipulations
|*| --------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1995, The SCRDRV project.
|*|
|*|	This program is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU General Public License as published by
|*|	the Free Software Foundation; either version 2, or (at your option)
|*|	any later version.
|*|
|*|	You should have received a copy of the GNU General Public License
|*|	along with this program; see the file COPYING.  If not, write to
|*|	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|*|
|*| ---------------------------------------------------------------------------
\*/

/* MAINTAINER	"Steffen Seeger, [seeger@physik.tu-chemnitz.de]" */

#ifndef DAC_PRECISION
  #error DAC_PRECISION undefined!
#endif

#define	SHIFT (GGI_COLOR_PRECISION - DAC_PRECISION)
#define	COLOR(X) ((X << SHIFT) | (X >> (DAC_PRECISION - SHIFT)))

static void
set_CLUT_entries(ggi_palette *table)
{
  int len;
  unsigned short *data;

  if (table && (data = (unsigned short *) table->data) && (len = table->cnt))
    {
      outbDAC(table->first, DAC_PW_INDEX);
      len += len + len;
      while (len--)
       outbDAC(*(data++) >> SHIFT, DAC_P_DATA);
    }
}

static int
get_CLUT_entries(ggi_palette *table, unsigned char index, int cnt)
{
  int len = 0;
  unsigned short *data;

  if (table && (data = (unsigned short *) table->data) && table->cnt)
    {
      len = (cnt > table->cnt) ? cnt : table->cnt;
      outbDAC((table->first = index), DAC_PR_INDEX);

      len += len + len;
      while (len--)
       {
         register unsigned short col = inbDAC(DAC_P_DATA);
         *(data++) = COLOR(col);
       }
    }
  return len;
}

